<!DOCTYPE html>
<html lang="en">

<head>
  <title>Task 150 Danh sách comment </title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container">
        <div class="row my-4">
            <h3><b style="color: violet;">DANH SÁCH</b> bình luận (comment) của bài viết</h3>
        </div>
        <div class="row form-group">
            <div class="col-sm-4">
                <label>Điền Post Id</label>
            </div>
            <div class="col-sm-8">
                <input type="text" id = "inp-dien-userid" placeholder="...điền post id, ví dụ 2,3..." class="form-control">
            </div>
        </div>
        <div class="row mb-4">
            <button id = "btn-lay-danh-sach" class="btn btn-success">Lấy danh sách bình luận của bài viết</button>
        </div>
        <table class="table table-bordered table-striped table-hover" id = "tbl-user-comment">
            <thead>
                <tr>
                <th>Id</th>
                <th>Post id</th>
                <th>Email</th>
                <th>Name (nhan đề)</th>
                <th>Body (nội dung)</th>
                <th>Action</th>
                </tr>
            </thead>
            <tbody>
                <tr>
                <td>1</td>
                <td>1</td>
                <td>Eliseo@gardner.biz</td>
                <td>d labore ex et quam laborum</td>
                <td>laudantium enim quasi est quidem</td>
                <td><button class="text-warning">Chi tiết</button></td>
                </tr>
                <tr>
                <td>2</td>
                <td>1</td>
                <td>Jayne_Kuhic@sydney.com</td>
                <td>quo vero reiciendis velit similique earum</td>
                <td>est natus enim nihil est dolore omnis voluptatem numquam\net o</td>
                <td><button class="text-warning">Chi tiết</button></td>
                </tr>
            </tbody>
        </table>
    </div>
</body>
<script>
    "use strict";

    /*** REGION 1 - Global variables - Vùng khai báo hằng số, tham số TOÀN CỤC */

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function(){
        $("#btn-lay-danh-sach").click(onBtnGetUserCommentClick);
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm thực thi khi ấn nút lấy danh sách bình luận của user
    function onBtnGetUserCommentClick(){
        "use strict";
        //Tạo đối tượng chứa dữ liệu
        var vUserObj = {
          postId: ""
        }
        //B1. Thu thập dữ liệu
        thuThapDuLieu(vUserObj);
        //B2. Validate dữ liệu
        var vKiemTra = kiemTraDuLieu(vUserObj);
        if (vKiemTra){
            //B3. Hiện thông tin cần tìm vào form
            callApiGetUserComment(vUserObj);
        }
    }

    //hàm xử lý sự kiện click button detail
    function onDetailButtonClick(paramEventsClick) {
      console.log("%cNút chi tiết được ấn","color:orange");
      var vButton = paramEventsClick.currentTarget;
      const vFORM_TO_OPEN = "Task 520CommentDetail.html"  //đây là form sẽ mở
      var vUrlToOpenPage = vFORM_TO_OPEN + "?"
                                         + "id=" + $(vButton).data("id");
      window.location.href = vUrlToOpenPage;
    }  

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //Hàm thu thập dữ liệu
    function thuThapDuLieu(paramUser){
        "use strict";
        paramUser.postId = $("#inp-dien-userid").val().trim();
    }

    //Hàm kiểm tra dữ liệu nhập vào
    function kiemTraDuLieu(paramUser){
        "use strict";
        if (paramUser.postId === ""){
            alert("Hãy nhập thông tin userID vào!");
            return false;
        }
        if (isNaN(paramUser.postId)){
            alert("Dữ liệu cần nhập phải là số nguyên!");
            return false;
        }
        return true;
    }

    //Hàm gọi Ajax get api
    function callApiGetUserComment(paramUser){
        "use strict";
        const vURL_GET_POST = "https://jsonplaceholder.typicode.com/users/" + paramUser.postId + "/comments";
        $.ajax({
          url: vURL_GET_POST,
          type: 'GET',
          dataType: 'json', // added data type
          success: function (res) {
            console.log(JSON.stringify(res));  //response text
            debugger;
            //4 xử lý hiện thị
            loadTableUserCommentData(res);  // responseObject là array các posts
            
          },
          error: function (ajaxContext) {
            alert(ajaxContext.responseText)
          }
        });
    }
    //hàm reset (xóa) dữ liệu của bảng user
    function resetTableData(){
        "use strict";
        $("#tbl-user-comment tbody").html("");  
    }

    //hàm load dữ liệu lên table
    function loadTableUserCommentData(paramUserCommentArray){
       "use strict";
       //xóa dữ liệu của bảng
       resetTableData();
       //đổ dữ liệu
       for (var bI = 0; bI < paramUserCommentArray.length; bI++) {
        //tạo row
        var bNewRow = $("<tr>").appendTo($("#tbl-user-comment tbody")); 
        //tao cell  
        $("<td>")  //cell user id 
          .html(paramUserCommentArray[bI].id)
          .appendTo(bNewRow);  //append hàng mới 

        $("<td>")
          .html(paramUserCommentArray[bI].postId)
          .appendTo(bNewRow);
          
        $("<td>")
          .html(paramUserCommentArray[bI].email)
          .appendTo(bNewRow);

        $("<td>")
          .html(paramUserCommentArray[bI].name)
          .appendTo(bNewRow);
   
        $("<td>")
          .html(paramUserCommentArray[bI].body)
          .appendTo(bNewRow);

        // xử lý cột action nút chi tiết
        var bColAction = $("<td>").addClass("btn-group").appendTo(bNewRow);
        var bDetailButton = 
        $("<button>")
          .addClass('btn btn-primary')
          .html("Chi tiết") 
          .appendTo(bColAction);

        //thêm dữ liệu vào nút 
        bDetailButton.attr("data-id", paramUserCommentArray[bI].id)
                      .attr("data-postId", paramUserCommentArray[bI].postId)
                      .attr("data-email", paramUserCommentArray[bI].email)
                      .attr("data-name", paramUserCommentArray[bI].name)
                      .attr("data-body", paramUserCommentArray[bI].body); 
         

        bDetailButton.click(onDetailButtonClick);  // thêm sự kiện cho nút
      }
  }
</script>
</html>